BZOJ 3887 [Usaco2015 Jan]Grass Cownoisseur

来源:互联网 发布:linux内核裁剪步骤 编辑:程序博客网 时间:2024/05/29 17:20

Description

In an effort to better manage the grazing patterns of his cows, Farmer John has installed one-way cow paths all over his farm. The farm consists of N fields, conveniently numbered 1..N, with each one-way cow path connecting a pair of fields. For example, if a path connects from field X to field Y, then cows are allowed to travel from X to Y but not from Y to X. Bessie the cow, as we all know, enjoys eating grass from as many fields as possible. She always starts in field 1 at the beginning of the day and visits a sequence of fields, returning to field 1 at the end of the day. She tries to maximize the number of distinct fields along her route, since she gets to eat the grass in each one (if she visits a field multiple times, she only eats the grass there once). As one might imagine, Bessie is not particularly happy about the one-way restriction on FJ's paths, since this will likely reduce the number of distinct fields she can possibly visit along her daily route. She wonders how much grass she will be able to eat if she breaks the rules and follows up to one path in the wrong direction. Please compute the maximum number of distinct fields she can visit along a route starting and ending at field 1, where she can follow up to one path along the route in the wrong direction. Bessie can only travel backwards at most once in her journey. In particular, she cannot even take the same path backwards twice.
给一个有向图,然后选一条路径起点终点都为1的路径出来,有一次机会可以沿某条边逆方向走,问最多有多少个点可以被经过?(一个点在路径中无论出现多少正整数次对答案的贡献均为1)

Input

The first line of input contains N and M, giving the number of fields and the number of one-way paths (1 <= N, M <= 100,000). The following M lines each describe a one-way cow path. Each line contains two distinct field numbers X and Y, corresponding to a cow path from X to Y. The same cow path will never appear more than once.

Output

A single line indicating the maximum number of distinct fields Bessie
can visit along a route starting and ending at field 1, given that she can
follow at most one path along this route in the wrong direction.

Sample Input

7 10
1 2
3 1
2 5
2 4
3 7
3 5
3 6
6 5
7 2
4 7

Sample Output

6

HINT

Source

Gold&鸣谢18357

[Submit][Status][Discuss]



哈哈,一开始只知道缩点,之后就苟且的看了题解。

求每一个点到1和1到每一个点的最大点权和。

注意一定要判断翻转一条边之后能否组成一个新环。

题解用的是拓扑排序,然而宝宝表示暴力搜索更适合我。

#include<iostream>#include<cstring>#include<cstdio>#include<stack>#include<queue>using namespace std;const int N=100005;int n,m,cnt,tim,dcnt,ans,hd[N],dfn[N],low[N],x[N],y[N],f[N][2],sz[N],belong[N],du[N][2];bool ins[N];stack<int>stk;queue<int>q;struct edge{    int to,nxt;}v[2*N];void addedge(int x,int y){    v[++cnt].to=y;    v[cnt].nxt=hd[x];    hd[x]=cnt;}void tarjan(int u){    dfn[u]=low[u]=++cnt;    ins[u]=1;    stk.push(u);    for(int i=hd[u];i;i=v[i].nxt)        if(!dfn[v[i].to])        {            tarjan(v[i].to);            low[u]=min(low[u],low[v[i].to]);        }        else if(ins[v[i].to])            low[u]=min(low[u],dfn[v[i].to]);    if(dfn[u]==low[u])    {        ++dcnt;        while(1)        {            int t=stk.top();            stk.pop();            belong[t]=dcnt;            ins[t]=0;            sz[dcnt]++;            if(u==t)                break;        }    }}void re(int ch){    cnt=0;    memset(hd,0,sizeof(hd));    for(int i=1;i<=m;i++)        if(belong[x[i]]!=belong[y[i]])            if(!ch)            {                addedge(belong[x[i]],belong[y[i]]);                du[belong[y[i]]][ch]++;            }            else            {                addedge(belong[y[i]],belong[x[i]]);                du[belong[x[i]]][ch]++;            }}void dfs(int u,int res,int ch){    if(f[u][ch]<res+sz[u])    {        f[u][ch]=res+sz[u];        for(int i=hd[u];i;i=v[i].nxt)            dfs(v[i].to,f[u][ch],ch);    }}int main(){    scanf("%d%d",&n,&m);    for(int i=1;i<=m;i++)    {        scanf("%d%d",&x[i],&y[i]);        addedge(x[i],y[i]);    }    for(int i=1;i<=n;i++)        if(!dfn[i])            tarjan(i);    re(0),dfs(belong[1],0,0);    re(1),dfs(belong[1],0,1);    for(int i=1;i<=m;i++)        if(belong[x[i]]!=belong[y[i]]&&f[belong[x[i]]][1]&&f[belong[y[i]]][0])            ans=max(ans,f[belong[x[i]]][1]+f[belong[y[i]]][0]-sz[belong[1]]);    printf("%d\n",ans);    return 0;}


0 0